% Image Degrade (Blur + Noise)
% input:
%    - f = image
%    - h = psf
%    - noise = amount of noise [0.0, 100.0]
%
% output
%    - g = degraded image
%
% Ex1: degrade image using a 3x3 mean filter without noise
%      g = degrade(f, ones(3,3)/9, 0)
%
% Ex2: degrade image using a 5x5 mean filter with 0.1 noise
%      g = degrade(f, ones(5,5)/25, 0.1)

function g = degrade(f, h, noise)

  H = fftn(h, size(f));
  F = fftn(f);
  G = F.*H;

  gb = real(ifftn(G));
  g = gb + randn(size(gb)).*noise;






