%
% input:
%    - g = degraded image
%    - h = psf
%    - method = inverse ou pseudo-inverse
%    - threshold = pseudo-inverse parameter
%    - r = real image
%
% output
%    - f = restored image
%    - e = restoration error (mean squared error)
%
function [f,e] = inversefilter(g, h, method, threshold, r)

  H = fftn(h, size(g));
  G = fftn(g);
  W = H; % filter
  if (method == 1) % inverse
     disp('Inverse Filter');
  else
     if (method == 2) % pseudo-inverse
	disp('Pseudo-inverse Filter');
        W(abs(H) < threshold) = threshold;
     end
  end
  f = real(ifftn( G./W )); % filter image
  e = sqrt(sum(sum( (f-r).^2 )));         







